/[gentoo-x86]/eclass/ghc-package.eclass
Gentoo

Contents of /eclass/ghc-package.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.28 - (hide annotations) (download)
Thu Jun 24 13:50:10 2010 UTC (4 years, 5 months ago) by kolmodin
Branch: MAIN
Changes since 1.27: +6 -2 lines
ghc-package.eclass: Fix for GHC 6.12.3 when having broken packages in your environment.

1 kosmikus 1.1 # Copyright 1999-2004 Gentoo Foundation
2     # Distributed under the terms of the GNU General Public License v2
3 kolmodin 1.28 # $Header: /var/cvsroot/gentoo-x86/eclass/ghc-package.eclass,v 1.27 2009/03/23 20:06:19 kolmodin Exp $
4 kosmikus 1.1 #
5     # Author: Andres Loeh <kosmikus@gentoo.org>
6 dcoutts 1.17 # Maintained by: Haskell herd <haskell@gentoo.org>
7 kosmikus 1.1 #
8     # This eclass helps with the Glasgow Haskell Compiler's package
9     # configuration utility.
10    
11 kosmikus 1.6 inherit versionator
12    
13 kosmikus 1.7 # promote /opt/ghc/bin to a better position in the search path
14     PATH="/usr/bin:/opt/ghc/bin:${PATH}"
15 kosmikus 1.1
16     # for later configuration using environment variables/
17     # returns the name of the ghc executable
18     ghc-getghc() {
19 kosmikus 1.22 type -P ghc
20 kosmikus 1.1 }
21    
22     # returns the name of the ghc-pkg executable
23     ghc-getghcpkg() {
24 kosmikus 1.22 type -P ghc-pkg
25 kosmikus 1.1 }
26    
27     # returns the name of the ghc-pkg binary (ghc-pkg
28     # itself usually is a shell script, and we have to
29 kosmikus 1.6 # bypass the script under certain circumstances);
30 kosmikus 1.15 # for Cabal, we add an empty global package config file,
31     # because for some reason the global package file
32     # must be specified
33 kosmikus 1.1 ghc-getghcpkgbin() {
34 kolmodin 1.27 if version_is_at_least "6.10" "$(ghc-version)"; then
35     # the ghc-pkg executable changed name in ghc 6.10, as it no longer needs
36     # the wrapper script with the static flags
37     echo '[]' > "${T}/empty.conf"
38     echo "$(ghc-libdir)/ghc-pkg" "--global-conf=${T}/empty.conf"
39     elif ghc-cabal; then
40 kosmikus 1.15 echo '[]' > "${T}/empty.conf"
41     echo "$(ghc-libdir)/ghc-pkg.bin" "--global-conf=${T}/empty.conf"
42 kosmikus 1.6 else
43 kosmikus 1.15 echo "$(ghc-libdir)/ghc-pkg.bin"
44 kosmikus 1.6 fi
45 kosmikus 1.1 }
46    
47     # returns the version of ghc
48 kosmikus 1.6 _GHC_VERSION_CACHE=""
49 kosmikus 1.1 ghc-version() {
50 kosmikus 1.6 if [[ -z "${_GHC_VERSION_CACHE}" ]]; then
51 dcoutts 1.16 _GHC_VERSION_CACHE="$($(ghc-getghc) --numeric-version)"
52 kosmikus 1.6 fi
53     echo "${_GHC_VERSION_CACHE}"
54     }
55    
56 kosmikus 1.15 # this function can be used to determine if ghc itself
57     # uses the Cabal package format; it has nothing to do
58     # with the Cabal libraries ... ghc uses the Cabal package
59     # format since version 6.4
60 kosmikus 1.6 ghc-cabal() {
61     version_is_at_least "6.4" "$(ghc-version)"
62 kosmikus 1.1 }
63    
64 kosmikus 1.15 # return the best version of the Cabal library that is available
65     ghc-bestcabalversion() {
66     local cabalversion
67     if ghc-cabal; then
68 dcoutts 1.19 # We ask portage, not ghc, so that we only pick up
69     # portage-installed cabal versions.
70 dcoutts 1.23 cabalversion="$(ghc-extractportageversion dev-haskell/cabal)"
71 kosmikus 1.15 echo "Cabal-${cabalversion}"
72     else
73     # older ghc's don't support package versioning
74     echo Cabal
75     fi
76     }
77    
78     # check if a standalone Cabal version is available for the
79     # currently used ghc; takes minimal version of Cabal as
80     # an optional argument
81     ghc-sanecabal() {
82     local f
83     local version
84     if [[ -z "$1" ]]; then version="1.0.1"; else version="$1"; fi
85     for f in $(ghc-confdir)/cabal-*; do
86     [[ -f "${f}" ]] && version_is_at_least "${version}" "${f#*cabal-}" && return
87     done
88     return 1
89     }
90    
91 dcoutts 1.23 # checks if ghc and ghc-bin are installed in the same version
92 swegener 1.26 # (if they're both installed); if this is not the case, we
93 dcoutts 1.23 # unfortunately cannot trust portage's dependency resolution
94     ghc-saneghc() {
95     local ghcversion
96     local ghcbinversion
97     if [[ "${PN}" == "ghc" || "${PN}" == "ghc-bin" ]]; then
98     return
99     fi
100     if has_version dev-lang/ghc && has_version dev-lang/ghc-bin; then
101     ghcversion="$(ghc-extractportageversion dev-lang/ghc)"
102     ghcbinversion="$(ghc-extractportageversion dev-lang/ghc-bin)"
103     if [[ "${ghcversion}" != "${ghcbinversion}" ]]; then
104     return 1
105     fi
106     fi
107     return
108     }
109    
110     # extract the version of a portage-installed package
111     ghc-extractportageversion() {
112     local pkg
113     local version
114     pkg="$(best_version $1)"
115     version="${pkg#$1-}"
116     version="${version%-r*}"
117     version="${version%_pre*}"
118     echo "${version}"
119     }
120    
121 kosmikus 1.1 # returns the library directory
122 kosmikus 1.6 _GHC_LIBDIR_CACHE=""
123 kosmikus 1.1 ghc-libdir() {
124 kosmikus 1.6 if [[ -z "${_GHC_LIBDIR_CACHE}" ]]; then
125     _GHC_LIBDIR_CACHE="$($(ghc-getghc) --print-libdir)"
126     fi
127     echo "${_GHC_LIBDIR_CACHE}"
128 kosmikus 1.1 }
129    
130     # returns the (Gentoo) library configuration directory
131     ghc-confdir() {
132 kosmikus 1.15 echo "$(ghc-libdir)/gentoo"
133 kosmikus 1.1 }
134    
135     # returns the name of the local (package-specific)
136     # package configuration file
137     ghc-localpkgconf() {
138     echo "${PF}.conf"
139     }
140    
141 kosmikus 1.3 # make a ghci foo.o file from a libfoo.a file
142     ghc-makeghcilib() {
143     local outfile
144     outfile="$(dirname $1)/$(basename $1 | sed 's:^lib\?\(.*\)\.a$:\1.o:')"
145 kosmikus 1.15 ld --relocatable --discard-all --output="${outfile}" --whole-archive "$1"
146     }
147    
148     # tests if a ghc package exists
149     ghc-package-exists() {
150 kolmodin 1.27 local describe_flag
151     if version_is_at_least "6.4" "$(ghc-version)"; then
152     describe_flag="describe"
153     else
154     describe_flag="--show-package"
155     fi
156    
157     $(ghc-getghcpkg) "${describe_flag}" "$1" > /dev/null 2>&1
158 kosmikus 1.3 }
159    
160     # creates a local (package-specific) package
161     # configuration file; the arguments should be
162     # uninstalled package description files, each
163     # containing a single package description; if
164     # no arguments are given, the resulting file is
165     # empty
166 kosmikus 1.1 ghc-setup-pkg() {
167 kosmikus 1.3 local localpkgconf
168     localpkgconf="${S}/$(ghc-localpkgconf)"
169 kosmikus 1.15 echo '[]' > "${localpkgconf}"
170 kolmodin 1.27 local update_flag
171     if version_is_at_least "6.4" "$(ghc-version)"; then
172     update_flag="update -"
173     else
174     update_flag="--update-package"
175     fi
176 dcoutts 1.10 for pkg in $*; do
177 kolmodin 1.27 $(ghc-getghcpkgbin) -f "${localpkgconf}" ${update_flag} --force \
178 kosmikus 1.15 < "${pkg}" || die "failed to register ${pkg}"
179 kosmikus 1.3 done
180 kosmikus 1.1 }
181    
182 araujo 1.9 # fixes the library and import directories path
183     # of the package configuration file
184     ghc-fixlibpath() {
185 kosmikus 1.15 sed -i "s|$1|$(ghc-libdir)|g" "${S}/$(ghc-localpkgconf)"
186 araujo 1.9 if [[ -n "$2" ]]; then
187 kosmikus 1.15 sed -i "s|$2|$(ghc-libdir)/imports|g" "${S}/$(ghc-localpkgconf)"
188 araujo 1.9 fi
189     }
190    
191 kosmikus 1.1 # moves the local (package-specific) package configuration
192     # file to its final destination
193     ghc-install-pkg() {
194 kosmikus 1.15 mkdir -p "${D}/$(ghc-confdir)"
195     cat "${S}/$(ghc-localpkgconf)" | sed "s|${D}||g" \
196     > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
197 kosmikus 1.1 }
198    
199     # registers all packages in the local (package-specific)
200     # package configuration file
201     ghc-register-pkg() {
202     local localpkgconf
203 kosmikus 1.3 localpkgconf="$(ghc-confdir)/$1"
204 kolmodin 1.27 local update_flag
205     local describe_flag
206     if version_is_at_least "6.4" "$(ghc-version)"; then
207     update_flag="update -"
208     describe_flag="describe"
209     else
210     update_flag="--update-package"
211     describe_flag="--show-package"
212     fi
213 kosmikus 1.15 if [[ -f "${localpkgconf}" ]]; then
214     for pkg in $(ghc-listpkg "${localpkgconf}"); do
215 kosmikus 1.8 ebegin "Registering ${pkg} "
216 kolmodin 1.27 $(ghc-getghcpkgbin) -f "${localpkgconf}" "${describe_flag}" "${pkg}" \
217     | $(ghc-getghcpkg) ${update_flag} --force > /dev/null
218 kosmikus 1.8 eend $?
219 kosmikus 1.7 done
220     fi
221 kosmikus 1.1 }
222    
223     # re-adds all available .conf files to the global
224     # package conf file, to be used on a ghc reinstallation
225     ghc-reregister() {
226 kosmikus 1.15 einfo "Re-adding packages (may cause several harmless warnings) ..."
227 kolmodin 1.27 PATH="/usr/bin:${PATH}" CONFDIR="$(ghc-confdir)"
228     if [ -d "${CONFDIR}" ]; then
229     pushd "${CONFDIR}" > /dev/null
230 kosmikus 1.5 for conf in *.conf; do
231 kolmodin 1.27 PATH="/usr/bin:${PATH}" ghc-register-pkg "${conf}"
232 kosmikus 1.5 done
233 kosmikus 1.8 popd > /dev/null
234 kosmikus 1.5 fi
235 kosmikus 1.1 }
236    
237 kosmikus 1.15 # unregisters a package configuration file
238     # protected are all packages that are still contained in
239     # another package configuration file
240 kosmikus 1.1 ghc-unregister-pkg() {
241     local localpkgconf
242 kosmikus 1.15 local i
243     local pkg
244     local protected
245 kolmodin 1.27 local unregister_flag
246 kosmikus 1.3 localpkgconf="$(ghc-confdir)/$1"
247 kosmikus 1.15
248 kolmodin 1.27 if version_is_at_least "6.4" "$(ghc-version)"; then
249     unregister_flag="unregister"
250     else
251     unregister_flag="--remove-package"
252     fi
253    
254 kosmikus 1.15 for i in $(ghc-confdir)/*.conf; do
255     [[ "${i}" != "${localpkgconf}" ]] && protected="${protected} $(ghc-listpkg ${i})"
256     done
257     # protected now contains the packages that cannot be unregistered yet
258    
259     if [[ -f "${localpkgconf}" ]]; then
260 kosmikus 1.7 for pkg in $(ghc-reverse "$(ghc-listpkg ${localpkgconf})"); do
261 kosmikus 1.15 if $(ghc-elem "${pkg}" "${protected}"); then
262     einfo "Package ${pkg} is protected."
263     elif ! ghc-package-exists "${pkg}"; then
264     :
265     # einfo "Package ${pkg} is not installed for ghc-$(ghc-version)."
266     else
267     ebegin "Unregistering ${pkg} "
268 kolmodin 1.27 $(ghc-getghcpkg) "${unregister_flag}" "${pkg}" --force > /dev/null
269 kosmikus 1.15 eend $?
270     fi
271 kosmikus 1.7 done
272     fi
273 kosmikus 1.1 }
274    
275     # help-function: reverse a list
276     ghc-reverse() {
277     local result
278 kosmikus 1.15 local i
279 kosmikus 1.1 for i in $1; do
280     result="${i} ${result}"
281     done
282 kosmikus 1.15 echo "${result}"
283     }
284    
285     # help-function: element-check
286     ghc-elem() {
287     local i
288     for i in $2; do
289     [[ "$1" == "${i}" ]] && return 0
290     done
291     return 1
292 kosmikus 1.1 }
293    
294     # show the packages in a package configuration file
295     ghc-listpkg() {
296 kosmikus 1.6 local ghcpkgcall
297 kosmikus 1.15 local i
298 kolmodin 1.28 local extra_flags
299     if version_is_at_least '6.12.3' "$(ghc-version)"; then
300     extra_flags="${extra_flags} -v0"
301     fi
302 kosmikus 1.15 for i in $*; do
303     if ghc-cabal; then
304 kolmodin 1.28 echo $($(ghc-getghcpkg) list ${extra_flags} -f "${i}") \
305 kosmikus 1.15 | sed \
306     -e "s|^.*${i}:\([^:]*\).*$|\1|" \
307     -e "s|/.*$||" \
308 dcoutts 1.25 -e "s|,| |g" -e "s|[(){}]||g"
309 kosmikus 1.15 else
310     echo $($(ghc-getghcpkgbin) -l -f "${i}") \
311     | cut -f2 -d':' \
312     | sed 's:,: :g'
313     fi
314     done
315 kosmikus 1.1 }
316    
317 kolmodin 1.21 # exported function: check if we have a consistent ghc installation
318     ghc-package_pkg_setup() {
319 dcoutts 1.23 if ! ghc-saneghc; then
320     eerror "You have inconsistent versions of dev-lang/ghc and dev-lang/ghc-bin"
321     eerror "installed. Portage currently cannot work correctly with this setup."
322     eerror "There are several possibilities to work around this problem:"
323     eerror "(1) Up/downgrade ghc-bin to the same version as ghc."
324     eerror "(2) Unmerge ghc-bin."
325     eerror "(3) Unmerge ghc."
326     eerror "You probably want option 1 or 2."
327     die "Inconsistent versions of ghc and ghc-bin."
328     fi
329 kolmodin 1.21 }
330    
331 kosmikus 1.1 # exported function: registers the package-specific package
332     # configuration file
333     ghc-package_pkg_postinst() {
334 kosmikus 1.15 ghc-register-pkg "$(ghc-localpkgconf)"
335 kosmikus 1.1 }
336    
337 kosmikus 1.15 # exported function: unregisters the package-specific package
338     # configuration file; a package contained therein is unregistered
339     # only if it the same package is not also contained in another
340     # package configuration file ...
341 kosmikus 1.1 ghc-package_pkg_prerm() {
342 kosmikus 1.15 ghc-unregister-pkg "$(ghc-localpkgconf)"
343 kosmikus 1.1 }
344    
345 kolmodin 1.21 EXPORT_FUNCTIONS pkg_setup pkg_postinst pkg_prerm

  ViewVC Help
Powered by ViewVC 1.1.20